<?php
include "cfgsecurity.php";

$fileMessage = "";
$reload = 0;
if(is_uploaded_file($_FILES["userfile"]["tmp_name"]))
{
  $uploaddir = "/var/www/conf/";
  $uploadfile = $uploaddir . basename($_FILES["userfile"]["name"]);

//check to make sure this is the file we are looking for
  $name = explode(".", $_FILES["userfile"]["name"]);
  if(strcmp($name[1], "gwi"))  //if the filetype is the wrong type
  {
    $fileMessage = "The file uploaded is not a GSC/VRC Web Interface firmware file, please only upload valid firmware files.";
  }
  else
  {
    if(move_uploaded_file($_FILES["userfile"]["tmp_name"], $uploadfile))
    {
     $fileMessage = "The firmware successfully uploaded, and the Web Interface is now rebooting. This may take up to 2 minutes. The applet may attempt to reconnect and fail, should this happen you will be required to login again.";
     $reload = 1;
     //now restart the WI
     $file = fopen('/tmp/reboot.txt', 'w');
     fclose($file);
    }
    else
    {
      $fileMessage = "The file uploaded did not verify, if this is a firmware file it may be corrupt.  Please redownload the file and try again.";
    }
   }
}

$html = "
<html>
<head>
<title>Firmware Uploader</title>
<STYLE TYPE='text/css'>
<!--
body { background-color: rgb(100,100,100); font-family: Arial, Helvetica, sans-serif; margin: 0px; }

P { font-size: 12px; color: rgb(240,240,240); line-height: 1.4em; }
 
P.SubHead { font-size: 18px; font-weight: bold; color: rgb(240,240,240); padding: 0px 0px 10px 0px; margin: 0px; }

input, select, input.x { font-size: 12px; color: black; }

a, a:visited, a:active { font-size: 12px; color: #F1B13A; text-decoration: underline }

div.section { width: 500px; padding: 10px; }
-->
</STYLE>
</head>";

if($reload == 1)
{
$html .= "<script language='javascript'>";
if(strlen($fileMessage) > 0)
  $html .= "tickCount = 120;";
$html .= "function init(){ update(); }";
$html .= "function update(){";
if(strlen($fileMessage) > 0)
{
  $html .= "minutes = Math.floor(tickCount / 60);
seconds = tickCount % 60;
";
  $html .= "if(seconds < 10)
{document.forms[\"form1\"].T1.value = minutes + \":0\" + seconds;}else {document.forms[\"form1\"].T1.value = minutes + \":\" + seconds;
} tickCount--;
if((minutes == 0) && (seconds == 0))
  alert(\"Firmware Update Complete, please log out and login again\");
else
  setTimeout(\"update()\", 1000);
";
}
$html.= "}";
$html .= "</script>";
}

$html .= "<body";

if($reload == 1)
  $html .= " onLoad='init()'";

$html .= ">
<div class='section'>
<p class='SubHead'>Update Firmware</p>
<p>To load new firmware on the Web Interface, download the desired firmware file from <span style='color: red;'><a href='http://www.burk.com/support'>our website</a></span> and save it on your computer.</p>
<p>After downloading the new firmware file to your PC, click the Browse button below to select the file for upload. Then click the Upload button to load the firmware to your Web Interface. It may take several minutes for the process to complete. The Web Interface will automatically restart when finished.</p>
<form name='upload' id='upload' method='post' action='' enctype='multipart/form-data'><input type='file' id='userfile' name='userfile' size='40'><input type='submit' name='Upload' value='Upload'> <input class='x' type='reset' value='Reset'></p></form>
";
if(strlen($fileMessage) > 0)
{
  $html .= "<p><font color=#66CCFF>" . $fileMessage . "</font></p>";
  if($reload == 1)
  {
  $html .= "<form method='POST' name='form1'><p><input type='text' name='T1' size='3'> Until restart</p></form>";
  }
}
$html .= "
</div>

</body>
</html>";
echo $html;
?>