<?php
include "cfgsecurity.php";

$firmware = "";

if($file = fopen("/tmp/firmware.txt", "r"))
{
  while(!feof ($file))
  {
    $line = fgets($file, 1024);
    $arr = explode("=", $line);
    if(eregi("firmware", $line))
    {
      $firmware = $arr[1];
    }
  }
}

function linuxUptime()
{
  $ut = strtok( exec( "cat /proc/uptime") , ".");
  $days = sprintf( "%2d", ($ut/(3600*24)));
  $hours = sprintf( "%2d", ( ($ut % (3600*24)) / 3600));
  $min = sprintf("%2d", ($ut % (3600*24) % 3600)/60);
  $sec = sprintf("%2d", ($ut % (3600*24) % 3600)%60);
  return array( $days, $hours, $min, $sec);
}
$uptime = linuxUptime();

function linuxMemory()
{
  exec( "cat /proc/meminfo", $retval);
  $count = count($retval);
  for($i = 0; $i < $count; $i++)
  {
    $memfree = explode(" ", $retval[$i]);
    $check = explode(":", $retval[$i]);
    if(!strncmp($check[0], "MemFree", 7))
    {
      $memunits = $memfree[count($memfree) - 1];
      $memval = $memfree[count($memfree) - 2];
      return array( $memval, $memunits );
    }
  }
  return array( "error", "kB" );
}
$memory = linuxMemory();

function linuxDiskSpace()
{
  $space = "";
  exec( "df", $retval);
  $count = count($retval);
  for($i = 0; $i < $count; $i++)
  {
    $diskinfo = explode(" ", $retval[$i]);
    if(count($diskinfo) < 5)
      continue;
    $check = $diskinfo[count($diskinfo) - 1];
    if(!strcmp($check, "/"))
    {
      if(!strcmp($diskinfo[count($diskinfo) - 3], ""))
        $space = $diskinfo[count($diskinfo) - 4];
      else
        $space = $diskinfo[count($diskinfo) - 3];
      break;
    }
  }
  return array( $space );
}
$diskspace = linuxDiskSpace();

$html = "<html><head><title>System Information</title></head><body>";
//TODO: add more system info here
$html .= "<p><b>System Information</b><br>";
$html .= "Firmware Version: " . $firmware . "<br>";
$html .= "Up Time: " . $uptime[0] . " days, " . $uptime[1] . "h:" . $uptime[2] . "m:" . $uptime[3] . "s<br>";
$html .= "Available Memory: " . $memory[0] . " " . $memory[1] . "<br>";
$html .= "Available Disk Space: " . $diskspace[0] . " kB</p>";

$html .= "<p>Message Priorities: <font color='red'>Critical</font> <font color='orange'>High</font>";
$html .= " <font color='black'>Normal</font> <font color='blue'>Low</font></p>";
$html .= "<table width='100%' border=1><tr><td><b>Time</b></td><td><b>Message</b></td></tr>";
include "/var/www/conf/sysinfo.php";
$html .= $log;
$html .= "</table></body></html>";
echo $html;
?>
