<?php
include "cfgsecurity.php";

function cleanUserData($string)
{
  $answer = ereg_replace("[^a-~,@-Z, ,!,#-&,(-?,_]","",$string);
  return $answer;
}

$message = "Configuration Saved";
//$empty = $postData = array(); //get the array of variables, and assign what needs to be
$ip = $_POST["IPAddr1"] . "." . $_POST["IPAddr2"] . "." . $_POST["IPAddr3"] . "." . $_POST["IPAddr4"];
$ip = cleanUserData($ip);
$ip_add = $_POST["IPAddr1"] . "." . $_POST["IPAddr2"] . "." . $_POST["IPAddr3"] . ".";
$ip_add = cleanUserData($ip_add);
$gateway = $_POST["Gateway1"] . "." . $_POST["Gateway2"] . "." . $_POST["Gateway3"] . "." . $_POST["Gateway4"];
$gateway = cleanUserData($gateway);
$netmask = $_POST["Netmask1"] . "." . $_POST["Netmask2"] . "." . $_POST["Netmask3"] . "." . $_POST["Netmask4"];
$netmask = cleanUserData($netmask);
$nameserver = $_POST["DNS1"] . "." . $_POST["DNS2"] . "." . $_POST["DNS3"] . "." . $_POST["DNS4"];
$nameserver = cleanUserData($nameserver);
$http_port = $_POST["HTTPPORT"];
$http_port = cleanUserData($http_port);
$tcp_port = $_POST["TCPPORT"];
$tcp_port = cleanUserData($tcp_port);

//attempt to write out the IP and NETMASK file
if($file = fopen("/etc/sysconfig/ifcfg-eth0", "w"))
{
  fwrite($file, "DEVICE=eth0\n");
  fwrite($file, "IPADDR=" . $ip . "\n");
  fwrite($file, "NETMASK=" . $netmask . "\n");
  fwrite($file, "NETWORK=" . $ip_add . "0\n");
  fwrite($file, "BROADCAST=" . $ip_add . "255\n");
  fwrite($file, "BOOTPROTO=static\n");
  fwrite($file, "ENABLE=yes\n");
  fwrite($file, "\n");
  fclose($file);
}

//attempt to write out the Gateway
if($file = fopen("/etc/sysconfig/network_cfg", "w"))
{
  fwrite($file, "### Technologic Systems\n");
  fwrite($file, "### General Network Configuration File\n");
  fwrite($file, "###\n");
  fwrite($file, "              NETWORKING=yes\n");
  fwrite($file, "              GATEWAY=" . $gateway . "\n");
  fwrite($file, "              GW_DEV=eth0\n");
  fwrite($file, "              HOSTNAME=\"SILVERBOX\"\n");
  fwrite($file, "              BOOTPROTO=no\n");
  fwrite($file, "              DEFRAG_IPV4=no\n");
  fwrite($file, "              FORWARD_IPV4=no\n");
  fclose($file);
}

//attempt to write out the nameserver
if($file = fopen("/etc/resolv.conf", "w"))
{
  fwrite($file, "nameserver " . $nameserver . "\n");
  fclose($file);
}

//attempt to write out the TCP info
if($file = fopen("/var/www/conf/tcp.txt", "w"))
{
  fwrite($file, "tcpport=" . $tcp_port . "\n");
  fclose($file);
}

//copy the http.conf to a bakup file
copy("/var/www/conf/httpd.conf", "/var/www/conf/httpd.conf.bak");

//attempt to write out the http port change
if($fr = fopen("/var/www/conf/httpd.conf.bak", "r"))
{
  if($file = fopen("/var/www/conf/httpd.conf", "w"))
  while(!feof ($fr))
  {
    $line = fgets($fr, 1024);
    $lineNumber = substr($line, 0, 1); //get the first char of the string
    if(($lineNumber != '#') && ($lineNumber != ' '))
    {
      if(!strncmp("Port", $line, 4))
      {
        fwrite($file, "Port " . $http_port . "\n");
      }
      else
      {
        fwrite($file, $line);
      }
    }
    else
    {
      fwrite($file, $line);
    }
  }
  fclose($file);
}



$html = "<html><head>";
$html .= "<STYLE TYPE='text/css'>
<!--
body { background-color: rgb(100,100,100); font-family: Arial, Helvetica, sans-serif; margin: 0px; }

P { font-size: 12px; color: rgb(240,240,240); line-height: 1.4em; }
 
P.SubHead { font-size: 18px; font-weight: bold; color: rgb(240,240,240); padding: 0px 0px 10px 0px; margin: 0px; }

input, select { font-size: 12px; color: black; }

a, a:visited, a:active { font-size: 12px; color: #F1B13A; text-decoration: underline }

div.section { width: 500px; padding: 10px; }
-->
</STYLE>";

$html .= "<title>GSC/VRC Web Interface Configuration: " . $message . "</title></head>";
$html .= "<body>";


$html .= "<p>" . $message . "</p>";
$html .= "<p>The Web Interface is currently rebooting.  Please allow 1 minute for the reboot to take place. The applet may attempt to reconnect and fail, should this happen you will be required to login again.</p>";
$html .= "<p>If you made any changes to the IP address or HTTP port, you will have to close the browser and type in the new info to login to the web interface.</p>";
$html .= "</body></html>";
echo $html;


//now restart the WI
 $file = fopen('/tmp/reboot.txt', 'w');
 fclose($file);
?>