<?php
include "cfgsecurity.php";

//read from the ifcfg-eth0 file for IPADDR and NETMASK
$ip = array("", "", "", "");
$netmask = array("", "", "", "");

if($file = fopen("/etc/sysconfig/ifcfg-eth0", "r"))
{  // if the file opens then do this work
  while(!feof ($file))
  {
    $line = fgets($file, 1024);
    $arr = explode("=", $line);
    if(eregi("IPADDR", $line))
    {
      $ip = explode('.', $arr[1]);
    }
    if(eregi("NETMASK", $line))
    {
      $netmask = explode('.', $arr[1]);
    }
  }
  fclose($file);
}

//read from the network_cfg file for the GATEWAY
$gateway = array("", "", "", "");

if($file = fopen("/etc/sysconfig/network_cfg", "r"))
{  // if the file opens then do this work
  while(!feof ($file))
  {
    $line = fgets($file, 1024);
    $arr = explode("=", $line);
    if(eregi("GATEWAY", $line))
    {
      $gateway = explode('.', $arr[1]);
    }
  }
  fclose($file);
}

//read the nameserver from the resolv.conf file
$nameserver = array("", "", "", "");

if($file = fopen("/etc/resolv.conf", "r"))
{  // if the file opens then do this work
  while(!feof ($file))
  {
    $line = fgets($file, 1024);
    $arr = explode(" ", $line);  //this one does not use am '=" sign it uses a space
    if(eregi("nameserver", $line))
    {
      $nameserver = explode('.', $arr[1]);
    }
  }
  fclose($file);
}

//read the httpd port from the http.conf file
$http_port = "";

if($file = fopen("/var/www/conf/httpd.conf", "r"))
{  // if the file opens then do this work
  while(!feof ($file))
  {
    $line = fgets($file, 1024);
    $lineNumber = substr($line, 0, 1); //get the first char of the string
    if(($lineNumber != '#') && ($lineNumber != ' '))
    {
      if(!strncmp("Port", $line, 4))
      {
        $arr = explode(" ", $line);
        $http_port = $arr[1];
      }
    }
  }
  fclose($file);
}

//read from the tcp.txt file for the TCP Port
$tcp_port = "4095";

if($file = fopen("/var/www/conf/tcp.txt", "r"))
{  // if the file opens then do this work
  while(!feof ($file))
  {
    $line = fgets($file, 1024);
    $arr = explode("=", $line);
    if(eregi("tcpport", $line))
    {
      $tcp_port = $arr[1];
    }
  }
  fclose($file);
}





$html = "<html>
<head>
<title>TCP/IP Settings</title>
<STYLE TYPE='text/css'>
<!--
body { background-color: rgb(100,100,100); font-family: Arial, Helvetica, sans-serif; margin: 0px; }

P { font-size: 12px; color: rgb(240,240,240); line-height: 1.4em; }
 
P.SubHead { font-size: 18px; font-weight: bold; color: rgb(240,240,240); padding: 0px 0px 10px 0px; margin: 0px; }

input, select { font-size: 12px; color: black; }

a, a:visited, a:active { font-size: 12px; color: #F1B13A; text-decoration: underline }

div.section { width: 500px; padding: 10px; }
-->
</STYLE>
</head>

<body>

<div class='section'>
<form method='POST' action='tcpWriter.php'>
<p class='SubHead'>TCP/IP Settings</p>
<p>TCP/IP settings are initially set up using HyperTerminal and a direct connection to the Web Interface. They can be edited here if your settings ever change. Check with your ISP or network administrator.</p><p class='b'><b>IP Address:</b><br><input type='text' name='IPAddr1' size='3' value='" . $ip[0] . "'>.<input type='text' name='IPAddr2' size='3' value='" . $ip[1] . "'>.<input type='text' name='IPAddr3' size='3' value='" . $ip[2] . "'>.<input type='text' name='IPAddr4' size='3' value='" . $ip[3] . "
'><p class='b'><b>Gateway:</b><br><input type='text' name='Gateway1' size='3' value='" . $gateway[0] . "'>.<input type='text' name='Gateway2' size='3' value='" . $gateway[1] . "'>.<input type='text' name='Gateway3' size='3' value='" . $gateway[2] . "'>.<input type='text' name='Gateway4' size='3' value='" . $gateway[3] . "
'><p class='b'><b>Subnet Mask:</b><br><input type='text' name='Netmask1' size='3' value='" . $netmask[0] . "'>.<input type='text' name='Netmask2' size='3' value='" . $netmask[1] . "'>.<input type='text' name='Netmask3' size='3'  value='" . $netmask[2] . "'>.<input type='text' name='Netmask4' size='3'  value='" . $netmask[3] . "
'></p><p class='b'><b>Name Server:</b><br><input type='text' name='DNS1' size='3' value='" . $nameserver[0] . "'>.<input type='text' name='DNS2' size='3' value='" . $nameserver[1] . "'>.<input type='text' name='DNS3' size='3' value='" . $nameserver[2] . "'>.<input type='text' name='DNS4' size='3' value='" . $nameserver[3] . "
'></p><p class='b'><b>TCP Port:</b><br><input type='text' name='TCPPORT' size='5' value='" . $tcp_port . "
'></p><p class='b'><b>HTTP Port:</b><br><input type='text' name='HTTPPORT' size='5' value='" . $http_port . "
'></p><p><input class='x' type='submit' value='Save' name='B1'>&nbsp;<input class='x' type='reset' value='Reset' name='B2'></p></form>
</div>

</body>
</html>";
echo $html;

?>
