<?php
include "cfgsecurity.php";

function cleanUserData($string)
{
  $answer = ereg_replace("[^a-~,@-Z, ,!,#-&,(-?,_]","",$string);
  return $answer;
}

$empty = $postData = array(); //get the array of variables
$path = "/var/www/conf/";
$filename = $_POST["filename"]; //get the filename that we will write touch
$fullFile = $path . $filename;
$backupFile = $fullFile . ".bak";
//output vars
$config = "Configuration Saved";
$message = "";
$message2 = "";

//check if the file exists
if(file_exists($fullFile))
{  //copy the file to a backup, in case of error
copy($fullFile, $backupFile);
//  if(!copy($fullFile, $backupFile))
//    echo "Failed to copy file";
}

//open the file for writing
if(!$file = fopen($fullFile, "w"))
{
  $config = "Configuration Failed";
  $message = "The server was unable to create or open the requested file";
  //echo "Cannot open the file";
}
else
{
  //add the configuration info into the file, as we grab the post
  foreach ($_POST as $varname => $varvalue)
  {
    if( empty($varvalue))
    {
      $empty[$varname] = $varvalue;
    }
    else
    {
      $linedata = $varname . "=" . cleanUserData($varvalue) . "\n";
      if(!fwrite($file, $linedata))
      {
        $config = "Configuration Failed";
        $message = "The server was unable to write to the requested file";
        //echo "unable to write to the file";
      }
      $postData[$varname] = cleanUserData($varvalue);
    }
  }
  //close the file
  fclose($file);
  //check if this is the email setting
  if(eregi("email.txt", $filename))
  {
    $message2 = "E-mail server changes may take several minutes to update"; 
  }
}

//display a confirmation that the file was written
$html = "<html><head><title>Configuration</title>";
$html .= "<STYLE TYPE='text/css'>
<!--
";
$html .= "P               {
        font-size: 12px;
        font-family: Arial, Helvetica, sans-serif;
        line-height: 1.5em;
        color: black;
}
";
$html .= "-->
</STYLE>";
$html .= "<script language='javascript'>";
$html .= "function init(){ setTimeout(\"window.parent.location='config.php'\", 3000); }";
$html .= "</script>";
$html .= "</head>
<body onLoad='init()'>
";
$html .= "<p>Configuration changes saved.</p>";
if(strlen($message2) > 0)
  $html .= "<p>" . $message2 . "</p>";
$html .= "<p>In 3 seconds you will automatically be redirected to the configuration page.</p>";
$html .= "<p>&nbsp;</p></body></html>";
echo $html;

?>